Program GetINI;  {Turbo Pascal Source}

{
Syntax:  showini [file] [section] [key]

errorlevel:
1 - [Section] not found on command line
2 - key not found on command line
3 - not enough parameters
4 - specific key not found in INI file
5 - INI file not found

By

Jim Scarletta
CIS: 73727,2276
MCI: Jscarletta@mcimail.com
}

uses CRT;  {must have this to redirect output!}

var SearchSection, SearchKey : string;
    SectionFound, KeyFound: boolean;
    Fin:text;
    s,value:string;

procedure Upper(var ss:string);
  var j:integer;
  begin
    for j:=1 to length(ss) do
      ss[j]:=Upcase(ss[j])
  end;

procedure DeSpace(var ss:string);
  var j:integer;
      t:string;
  begin
    t:=ss;
    ss:='';
    for j:=1 to length(t) do
      if t[j]<>' ' then
        ss:=ss+t[j]
  end;

procedure GetSearchKey;
  var j:integer; p:string;
      SectionDone:Boolean;
  begin
    SearchSection:='';
    SearchKey:='';
    SectionDone:=False;
    j:=2;
    while (j<=paramcount) and not(SectionDone) do begin
      p:=paramstr(j);
      if p[length(p)]=']' then
        SectionDone:=true;
      SearchSection:=SearchSection+paramstr(j);
      j:=j+1;
      end;
    if not SectionDone then begin
      writeln('[Section] not found on command line');
      Halt(1);
      end;
    if j <= paramcount then
      repeat
        SearchKey:=SearchKey+paramstr(j);
        j:=j+1
      until j> paramcount
    else begin
      writeln('key not found on command line');
      halt(2);
      end;
    upper(SearchSection);
    upper(SearchKey);
  end;

Procedure FindKey;
  begin
    while (not(EOF(Fin)) and not(KeyFound)) do Begin
      readln(fin,s);
      value:=s;
      despace(s);
      upper(s);
      if SectionFound then begin
        if copy(s,1,pos('=',s)-1)=SearchKey then begin
          KeyFound:=True
          end
        end
      else
        if s=SearchSection then
          SectionFound:=True;
      end;
    close(fin);
  end;


Procedure Init;
  begin
    if paramcount < 3 then begin
      writeln('getini [section] key');
      writeln('...by Jim Scarletta');
      halt(3);
      end;
    assign(fin,paramstr(1));
{$I-}
    reset(fin);
    if ioresult <> 0 then begin
      writeln('INI File not found');
      halt(5);
      end;
{$I+}
    KeyFound:=False;
    SectionFound:=False;
    GetSearchKey
  end;

begin
  init;
{  writeln('Searching for: ',SearchSection,' : ',SearchKey); }
  FindKey;
  if KeyFound then
    write(copy(value,pos('=',value)+1,length(value)))
  else begin
    writeln('Key Not Found');
    halt(4);
    end
end.

